package com.fp.persistence.parmas.inte;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import javax.persistence.Version;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMLECTURADETALLE*/
@Entity(name="TarmLecturaDetalle")
@Table(name="TARMLECTURADETALLE")
public class TarmLecturaDetalle extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmLecturaDetalle
*/
@EmbeddedId
private TarmLecturaDetalleKey pk;
/**Contructor por defecto*/
public TarmLecturaDetalle(){
}
/**Contructor de TarmLecturaDetalle
@param pPk Clave Primaria del entity
*/
public TarmLecturaDetalle(TarmLecturaDetalleKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmLecturaDetalle
*/
public static TarmLecturaDetalle find(EntityManager pEntityManager,TarmLecturaDetalleKey pKey) throws Exception{
    TarmLecturaDetalle obj = pEntityManager.find(TarmLecturaDetalle.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmLecturaDetalle
@return El objeto que referencia a la Clave primaria de TarmLecturaDetalle
*/
public TarmLecturaDetalleKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmLecturaDetalle
@param pPk El objeto que referencia a la nueva Clave primaria de TarmLecturaDetalle
*/
public void setPk(TarmLecturaDetalleKey pPk){
  pk=pPk;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmLecturaDetalle))return false;
    TarmLecturaDetalle that = (TarmLecturaDetalle) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmLecturaDetalle
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmLecturaDetalle
*/
public Object createInstance(){
 TarmLecturaDetalle instance=new TarmLecturaDetalle();	
 instance.setPk(new TarmLecturaDetalleKey());
 return instance;
}
/**Clona la entidad TarmLecturaDetalle
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmLecturaDetalle p=(TarmLecturaDetalle)this.clone();
  p.setPk((TarmLecturaDetalleKey)this.pk.cloneMe());
  return p;
}
}
